<?php

class SWFUploadFileIFrameField_Uploader extends Image_Uploader
{
	/**
	 * Ensures the css is loaded for the iframe.
	 */
	function iframe() {
		if(!Permission::check('ADMIN')) Security::permissionFailure($this);
		
		Requirements::css("cms/css/Image_iframe.css");
		return array();
	}
	
	protected function getSWFUploadField($form_name)
	{
		return new SWFUploadField($form_name,"Upload","", array(
			'file_queue_limit' => '1',
			'file_upload_limit' => '1',
			'upload_url' => '/swfuploadfile/handleswfupload'
		));
	}
	
	/**
	 * Form to show the current image and allow you to upload another one.
	 * @return Form
	 */
	function EditImageForm() {
		$isImage = $this->IsImage();
		$type =  $isImage ? _t('Controller.IMAGE', "Image") : _t('Controller.FILE', "File");
		if($this->Image()->ID) {
			$title = sprintf(
				_t('ImageUploader.REPLACE', "Replace %s", PR_MEDIUM, 'Replace file/image'), 
				$type
			);
			$fromYourPC = _t('ImageUploader.ONEFROMCOMPUTER', "With one from your computer");
			$fromTheDB = _t('ImageUplaoder.ONEFROMFILESTORE', "With one from the file store");
		} else {
			$title = sprintf(
				_t('ImageUploader.ATTACH', "Attach %s", PR_MEDIUM, 'Attach image/file'),
				$type
			);
			$fromYourPC = _t('ImageUploader.FROMCOMPUTER', "From your computer");
			$fromTheDB = _t('ImageUploader.FROMFILESTORE', "From the file store");
		}
		
		SWFUploadConfig::addPostParam("Class",$this->urlParams['Class']);
		SWFUploadConfig::addPostParam("ID",$this->urlParams['ID']);
		SWFUploadConfig::addPostParam("Field",$this->urlParams['Field']);
		
		return new Form(
			$this, 
			'EditImageForm', 
			new FieldSet(
				new HiddenField("Field","",$this->urlParams['Field']),
				new HeaderField($title),

				new SelectionGroup("ImageSource", array(
					"new//$fromYourPC" => new FieldGroup("",
						$this->getSWFUploadField('EditImageForm')					
					),
					"existing//$fromTheDB" => new FieldGroup("",
						new TreeDropdownField("ExistingFile", "","File")
					)
				))
				
			),
			new FieldSet(
				new FormAction("save",$title)
			)
		);
	}
	
	/**
	 * A simple version of the upload form.
	 * @returns string
	 */
	function EditImageSimpleForm() {
		$isImage = $this->IsImage();
		$type =  $isImage ? _t('Controller.IMAGE') : _t('Controller.FILE');
		if($this->Image()->ID) {
			$title = sprintf(
				_t('ImageUploader.REPLACE'), 
				$type
			);
			$fromYourPC = _t('ImageUploader.ONEFROMCOMPUTER');
		} else {
			$title = sprintf(
				_t('ImageUploader.ATTACH'), 
				$type
			);
			$fromTheDB = _t('ImageUploader.ONEFROMFILESTORE');
		}
		
		return new Form($this, 'EditImageSimpleForm', new FieldSet(
			new HiddenField("Class", null, $this->urlParams['Class']),
			new HiddenField("ID", null, $this->urlParams['ID']),
			new HiddenField("Field", null, $this->urlParams['Field']),
			new FileField("Upload","")
		),
		new FieldSet(
			new FormAction("save",$title)
		));
	}

	function handleswfupload() {
		$data = $_POST;
		$owner = DataObject::get_by_id($data['Class'], $data['ID']);
		$fieldName = $data['Field'] . 'ID';
		
			// TODO We need to replace this with a way to get the type of a field
			$imageClass = $owner->has_one($data['Field']);
		
			// If we can't find the relationship, assume its an Image.
			if( !$imageClass) {
				if(!is_subclass_of( $imageClass, 'Image' )){
					$imageClass = 'Image';	
				}
			}
			// Assuming its a decendant of File
			$image = new $imageClass();
			$image->loadUploaded($_FILES['swfupload_file']);
			$owner->$fieldName = $image->ID;
			
		    // store the owner id with the uploaded image
    		if($member = Member::currentUser())
				$image->OwnerID = $member->ID;
			$image->write();

		$owner->write();
		/** HACK ALERT: SWFUpload doesn't like HTTP 302 status codes. Manual redirectBack() here */
		echo ' ';
		echo 
		"<p>Redirecting to <a href=\"$url\" title=\"Please click this link if your browser does not redirect you\">$url... (output started on $file, line $line)</a></p>
		<meta http-equiv=\"refresh\" content=\"1; url=$url\" />
		<script type=\"text/javascript\">setTimeout('window.location.href = \"$url\"', 50);</script>";	
	}

	
	
	/**
	 * Save the data in this form.
	 */
	function save($data, $form) {		
		if($data['ImageSource'] == 'existing') {
			$owner = DataObject::get_by_id($data['Class'], $data['ID']);
			$fieldName = $data['Field'] . 'ID';
			if(!$data['ExistingFile']) {
				// No image has been selected
				Director::redirectBack();
				return;
			}
			
			$owner->$fieldName = $data['ExistingFile'];

			// Edit the class name, if applicable
			$existingFile = DataObject::get_by_id("File", $data['ExistingFile']);
			$desiredClass = $owner->has_one($data['Field']);
			
			// Unless specifically asked, we don't want the user to be able
			// to select a folder
			if(is_a($existingFile, 'Folder') && $desiredClass != 'Folder') {
				Director::redirectBack();
				return;
			}
			
			if(!is_a($existingFile, $desiredClass)) {
				$existingFile->ClassName = $desiredClass;
				$existingFile->write();
			}
		
			$owner->write();
			Director::redirectBack();

		} else {
			// Nothing to do here. It has handled by handleswfupload()
			Director::redirectBack();
		}	
	}

}


?>